/* リスト3.2 IDマーカを認識して立方体を表示するサンプル */

import jp.nyatla.nyar4psg.*;  // NyAR4psg
import processing.video.*;    // ビデオライブラリ

Capture cam;    // キャプチャ
MultiMarker ar; // ARマーカに関する処理をするオブジェクト
int id;         // マーカに割り当てられるID番号

void setup() {
  size(640,480,P3D); // 画面の設定
  cam = new Capture(this, width, height); // キャプチャの準備
  ar = new MultiMarker(this, width, height, "camera_para.dat", NyAR4PsgConfig.CONFIG_PSG);
  id = ar.addARMarker(123,40); // IDマーカのID番号とサイズの登録
}

void draw() {
  if (cam.available()==false) return;  // カメラの用意ができていないときは処理をしない
  cam.read();             // カメラ画像の読み込み  
  background(0);          // 画面の初期化
  ar.drawBackground(cam); // 背景画像の描画
  ar.detect(cam);         // マーカ認識

  // マーカが認識されていたら
  if ( ar.isExistMarker(id) ) {
    ar.beginTransform(id);
    fill(116,163,241,100); // 立方体の色
    translate(0,0,20);     // 立方体をマーカ上に載せるために上方向に移動
    box(40);               // 一辺が40mmの立方体を描画
    ar.endTransform();
  }
}
