/* リスト3.8 ARマーカを使って重畳表示したCGに対してポップアップメニューを表示 */

import ppopupmenu.*;
import picking.*;
import processing.video.*;
import processing.opengl.*;
import jp.nyatla.nyar4psg.*;

Capture cam = null;
MultiMarker ar = null;
Picker picker = null;
PPopupMenu menu = null;
color box_color = #ffffff;

void setup(){
  size(640, 480, P3D);
  ar = new MultiMarker(this, width, height, "camera_para.dat", NyAR4PsgConfig.CONFIG_PSG );
  ar.addARMarker("patt.hiro", 80);
  cam = new Capture(this, 640, 480);
  picker = new Picker(this);
  menu = new PPopupMenu(this);

  menu.addMenuItem("red", "changeBoxColorRed");
  menu.addMenuItem("green", "changeBoxColorGreen");
  menu.addMenuItem("blue", "changeBoxColorBlue");
  menu.addMenuItem("yellow", "changeBoxColorYellow");
  menu.addMenuItem("purple", "changeBoxColorPurple");
  menu.addMenuItem("cyan", "changeBoxColorCyan");
}

void draw(){
  if (cam.available()==false) return;

  cam.read();             // カメラ画像の読み込み
  background(0);          // 画面の初期化
  ar.drawBackground(cam); // 背景画像の描画
  ar.detect(cam);         // マーカ認識

  if ( ar.isExistMarker(0) ) {
    picker.start(0);
    ar.beginTransform(0);
      fill(box_color);
      translate(0, 0, 20);
      box(40);
    ar.endTransform();
    picker.stop();
  }
}

void mouseClicked() {
  if (mouseButton==RIGHT){
    int id = picker.get(mouseX, mouseY);
    if ( id == 0 ) {
        if ( !ar.isExistMarker(0) ) return;
        menu.show();
    }
  } else {
    box_color = #ffffff;
  }
}

void changeBoxColorRed(){
  box_color = #ff0000;
}
void changeBoxColorGreen(){
  box_color = #00ff00;
}
void changeBoxColorBlue(){
  box_color = #0000ff;
}
void changeBoxColorYellow(){
  box_color = #ffff00;
}
void changeBoxColorPurple(){
  box_color = #ff00ff;
}
void changeBoxColorCyan(){
  box_color = #00ffff;
}
